//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

::CreateAoE <-  function(origin, radius, applyFunc, applyBuildingFunc = null)
{
    foreach(target in GetAlivePlayers())
    {
        local deltaVector = target.GetOrigin() - origin;
        local distance = deltaVector.Length();
        if (distance <= radius)
            applyFunc(target, deltaVector, distance);
    }

    local target = null;
    while (target = Entities.FindByClassname(target, "obj_*"))
    {
        local deltaVector = target.GetOrigin() - origin;
        local distance = deltaVector.Length();
        if (distance <= radius)
        {
            if (applyBuildingFunc)
                applyBuildingFunc(target, deltaVector, distance);
            else
                applyFunc(target, deltaVector, distance);
        }
    }
}

::CreateAoEAABB <- function(origin, min, max, applyFunc, applyBuildingFunc)
{
    local min = origin + min;
    local max = origin + max;
    foreach(target in GetAlivePlayers())
    {
        local targetOrigin = target.GetOrigin();
        if (targetOrigin.x >= min.x
            && targetOrigin.y >= min.y
            && targetOrigin.z >= min.z
            && targetOrigin.x <= max.x
            && targetOrigin.y <= max.y
            && targetOrigin.z <= max.z)
            {
                local deltaVector = target.GetOrigin() - origin;
                applyFunc(target, deltaVector, deltaVector.Length());
            }
    }

    local target = null;
    while (target = Entities.FindByClassname(target, "obj_*"))
    {
        local targetOrigin = target.GetOrigin();
        if (targetOrigin.x >= min.x
            && targetOrigin.y >= min.y
            && targetOrigin.z >= min.z
            && targetOrigin.x <= max.x
            && targetOrigin.y <= max.y
            && targetOrigin.z <= max.z)
            {
                if (applyBuildingFunc)
                    applyBuildingFunc(target, deltaVector, distance);
                else
                    applyFunc(target, deltaVector, distance);
            }
    }
}

::clampCeiling <- function(valueA, valueB)
{
    if (valueA < valueB)
        return valueA;
    return valueB;
}
::min <- clampCeiling;

::clampFloor <- function(valueA, valueB)
{
    if (valueA > valueB)
        return valueA;
    return valueB;
}
::max <- clampFloor;

::clamp <- function(value, min, max)
{
    if (value < min)
        return min;
    if (value > max)
        return max;
    return value;
}

::safeget <- function(table, field, defValue)
{
    return field in table ? table[field] : defValue;
}

::SetPersistentVar <- function(name, value)
{
    local persistentVars = tf_gamerules.GetScriptScope();
    persistentVars[name] <- value;
}

::GetPersistentVar <- function(name, defValue = null)
{
    local persistentVars = tf_gamerules.GetScriptScope();
    return name in persistentVars ? persistentVars[name] : defValue;
}