IncludeScript("gungame/gamemode/scoreboard.nut")
IncludeScript("gungame/gamemode/assist_manager.nut")
IncludeScript("gungame/gamemode/weapons/_weapons.nut")
IncludeScript("gungame/gamemode/victory_screen.nut")

Convars.SetValue("tf_weapon_criticals", 1);
Convars.SetValue("mp_friendlyfire", 1);
Convars.SetValue("mp_autoteambalance", 0);
Convars.SetValue("mp_teams_unbalance_limit", 0);
Convars.SetValue("tf_classlimit", 0);
Convars.SetValue("cl_use_tournament_specgui", 0);
Convars.SetValue("mp_forcecamera", 0);
Convars.SetValue("sv_alltalk", 1);
Convars.SetValue("tf_dropped_weapon_lifetime", 0);
Convars.SetValue("mp_scrambleteams_auto", 0);
Convars.SetValue("mp_disable_respawn_times", 1);
Convars.SetValue("sv_vote_issue_autobalance_allowed", "0");
Convars.SetValue("tf_spawn_glows_duration", "0");
Convars.SetValue("tf_avoidteammates", "0");
Convars.SetValue("sv_vote_issue_scramble_teams_allowed", "0");
Convars.SetValue("tf_use_fixed_weaponspreads", "1");

team_round_timer = SpawnEntityFromTable("team_round_timer", {
    targetname = "team_round_timer",
    auto_countdown = 1,
    max_length = 0,
    reset_time = 1,
    show_in_hud = 1,
    show_time_remaining = 1,
    start_paused = 0,
    timer_length = 345,
    StartDisabled = 0,
    "OnFinished": "!self,RunScriptCode,main_script.EndRound(),0,-1"
});

game_text <- SpawnEntityFromTable("game_text",
    {
        targetname = "game_text",
        color = "236 227 203",
        color2 = "0 0 0",
        channel = 0,
        effect = 0,
        fadein = 0,
        fadeout = 0,
        fxtime = 0,
        holdtime = 250,
        spawnflags = 1,
        x = -1,
        y = -1,
        message = "",
    });

::ended <- false;

function EndRound(winner = null)
{
    ::ended <- true;
    if (!winner)
    {
        local sorted = GetScoreboardSorted();
        winner = PlayerInstanceFromIndex(sorted[0][0])
    }

    winner.KeyValueFromString("targetname", "winner");

    local roundWin = SpawnEntityFromTable("game_round_win",
    {
        win_reason = "0",
        force_map_reset = "1", //not having
        TeamNum = "0",         //these 3 lines
        switch_teams = "0"     //causes the crash when trying to fire game_round_win
    });
    EntFireByHandle(roundWin, "SetTeam", ""+winner.GetTeam(), 0.1, null, null);
    EntFireByHandle(roundWin, "RoundWin", "", 0.1, null, null);
    return;
}

OnGameEvent("player_team", 0, function(player, params)
{
    if (params.oldteam < 2)
        EntFireByHandle(player, "RunScriptFile", "gungame/player/mercenary/_mercenary.nut", -1, player, player);
});

foreach(player in GetAllClients())
{
    EntFireByHandle(player, "RunScriptFile", "gungame/player/mercenary/_mercenary.nut", -1, player, player);
}