damageTables <- player_collection(player_collection(0));
::assists <- player_collection(0);

OnGameEvent("player_hurt", 100, function(victim, params)
{
    local attacker = GetPlayerFromParams(params, "attacker");
    if (IsValidClient(attacker))
        damageTables[victim.entindex()][attacker.entindex()] += params.damageamount;
    else
        attacker = victim;

    if (victim.GetHealth() <= params.damageamount)
    {
        local assister = GetAssister(victim, attacker)
        if (assister != victim)
            victim.AddCondEx(TF_COND_URINE, 0, assister);
    }
})

OnGameEvent("player_death", 0, function(victim, params)
{
    if (params.customkill == TF_DMG_CUSTOM_SUICIDE)
    {
        local assister = GetAssister(victim, victim);
        if (assister != victim)
            SendGlobalGameEvent("player_death", {
                userid = GetUserID(victim),
                attacker = GetUserID(assister),
                customkill = 0
            })
    }
});

OnGameEvent("player_death", -10, function(victim, params)
{
    local assister = GetPlayerFromParams(params, "assister");
    if (!IsValidClient(assister) || GetCurrentGunGameWeapon(assister) == GetWeaponTypeByName("golden_crowbar"))
        return;
    if (++assists[assister.entindex()] >= 2)
    {
        assists[assister.entindex()] = 0;
        kills[assister.entindex()]++;
        assister.GetScriptScope().SwitchToNextWeapon();
    }
    EmitSoundEx({
        sound_name = "ui/hitsound_electro1.wav",
        filter_type = RECIPIENT_FILTER_SINGLE_PLAYER,
        entity = assister,
        filter_param = assister,
        speaker_entity = assister
    });
});

function GetAssister(victim, attacker)
{
    local assister = victim.entindex();
    attacker = attacker.entindex();
    local damage = 20;
    foreach(iAssister, iDamage in damageTables[victim.entindex()])
    {
        if (iDamage > damage && iAssister != attacker)
        {
            assister = iAssister;
            damage = iDamage;
        }
    }
    return PlayerInstanceFromIndex(assister);
}

OnGameEvent("player_spawn", 0, function(player, params)
{
    damageTables[player.entindex()] = player_collection(0);
});

AddTimer(1, 0, function()
{
    foreach(damageTable in damageTables)
        foreach(player, damage in damageTable)
            if (damage > 0)
                damageTable[player] = damage - 5;
})