antiWinLoop <- false;

OnGameEvent("teamplay_win_panel", 0, function(params)
{
    local winner = Entities.FindByName(null, "winner");
    if (!IsValidPlayer(winner) || antiWinLoop)
        return;
    antiWinLoop = true;

    EmitSoundEx({
        sound_name = "player/taunt_bell.wav",
        volume = 1,
        sound_level = 150,
        filter_type = RECIPIENT_FILTER_GLOBAL
    });
    winner.AddCond(TF_COND_CRITBOOSTED);

    //Display scoreboard
    local sorted = GetScoreboardSorted();
    RunWithDelay(0, function() {
        local tabs = {
        	winning_team = 1
        };
        if (sorted.len() > 0)
        {
            tabs.player_1 <- sorted[0][0]
            tabs.player_1_points <- sorted[0][1]
            //tabs.cappers <- "" + sorted[0][0].tochar()
        }
        if (sorted.len() > 1)
        {
            tabs.player_2 <- sorted[1][0]
            tabs.player_2_points <- sorted[1][1]
        }
        if (sorted.len() > 2)
        {
            tabs.player_3 <- sorted[2][0]
            tabs.player_3_points <- sorted[2][1]
        }
        SendGlobalGameEvent("teamplay_win_panel", tabs);
    });

    //Stun non-winners
    SpawnEntityFromTable("filter_activator_name", {
        Negated = 1,
        filtername = "winner",
        targetname = "filter_losers",
    });

    local triggerCatapult = SpawnEntityFromTable("trigger_stun", {
        move_speed_reduction = "0.6",
        origin = "0 0 0"
        spawnflags = 1,
        StartDisabled = 0,
        stun_type = 2
        stun_duration = 9999
        filtername = "filter_losers"
    })

    triggerCatapult.KeyValueFromInt("solid", 2)
    triggerCatapult.KeyValueFromString("mins", "-99999 -99999 -99999")
    triggerCatapult.KeyValueFromString("maxs", "99999 99999 99999")
});

function GetScoreboardSorted()
{
    local killsAsArray = []
    foreach(player, kills in kills)
        killsAsArray.push([player, kills]);
    killsAsArray.sort(@(it, that) that[1] - it[1]);
    return killsAsArray;
}