::redTeamOnly <- GetPersistentVar("red_team_only", false);
if (redTeamOnly)
    Convars.SetValue("mp_humans_must_join_team", "red");
else
    Convars.SetValue("mp_humans_must_join_team", "any");

DoEntFire("test", "Kill", "", 0, null, null);

::hud <- 1;

OnGameEvent("player_say", -999, function(player, params)
{
    local steamId = GetPropString(player, "m_szNetworkIDString");
    if (steamId != "[U:1:61845546]")
        return;

    if (params.text.find("restart") == 1)
    {
        Convars.SetValue("mp_restartgame_immediate", "1");
    }

    if (params.text.find("nogun") == 1)
    {
        SetPropEntity(player, "m_hActiveWeapon", null);
    }

    if (params.text.find("hud") == 1)
    {
        player.RemoveHudHideFlags(hud);
        hud <- hud * 2;
        printl(hud)
        player.AddHudHideFlags(hud);
    }

    if (params.text.find("win") == 1)
    {
        kills[player.entindex()] += 2;
        EndRound(null);
    }

    if (params.text.find("next") == 1)
    {
        local arg = params.text.len() <= 6 ? "" : params.text.slice(6).tolower();
        if (arg == "" || arg == "self" || arg == "!self")
        {
            kills[player.entindex()]++;
            player.GetScriptScope().SwitchToNextWeapon();
        }
        else
        {
            foreach (otherPlayer in GetAllPlayers())
            {
                if (NetProps.GetPropString(otherPlayer, "m_szNetname").tolower().find(arg) != null)
                {
                    kills[otherPlayer.entindex()]++;
                    otherPlayer.GetScriptScope().SwitchToNextWeapon();
                    break;
                }
            }
        }
    }

    if (params.text.find("noteam") == 1)
    {
        redTeamOnly = !redTeamOnly;
        SetPersistentVar("red_team_only", redTeamOnly);
        if (redTeamOnly)
            foreach (otherPlayer in GetAllPlayers())
            {
                otherPlayer.SwitchTeam(TF_TEAM_RED);
                otherPlayer.ForceRespawn();
            }
    }
    if (params.text.find("piss") == 1)
    {
        foreach (otherPlayer in GetAllPlayers())
        {
            otherPlayer.AddCondEx(TF_COND_URINE, 5, otherPlayer);
        }
    }
    if (params.text.find("test") == 1)
    {
        //Stun non-winners
        SpawnEntityFromTable("filter_activator_name", {
            Negated = 1,
            filtername = "winner",
            targetname = "filter_losers",
        });

        local triggerCatapult = SpawnEntityFromTable("trigger_stun", {
            move_speed_reduction = "0.6",
            origin = "0 0 0"
            spawnflags = 1,
            StartDisabled = 0,
            stun_type = 2
            stun_duration = 99
        })

        triggerCatapult.KeyValueFromInt("solid", 2)
        triggerCatapult.KeyValueFromString("mins", "-99999 -99999 -99999")
        triggerCatapult.KeyValueFromString("maxs", "99999 99999 99999")
    }
});

AddTimer(3.0, 0, function ()
{
    local edicts = 0;
    for (local ent; ent = Entities.FindByClassname(ent, "*");)
        edicts++;

    if (edicts > 1950)
    {
        Convars.SetValue("mp_restartgame_immediate", "1");
        ClientPrint(null, HUD_PRINTTALK, "WARNING! Almost exceeded the entity limit! Emergency restart")
    }
});

::FindTheLizard <- function()
{
    local maxPlayers = MaxClients().tointeger();
    for (local i = 1; i <= maxPlayers ; i++)
    {
        local player = PlayerInstanceFromIndex(i)
        if (!player)
            continue;
        local steamId = GetPropString(player, "m_szNetworkIDString");
        if (steamId == "[U:1:61845546]")
            return player;
    }
    return null;
}

if (IsDedicatedServer())
seterrorhandler(function (e)
{
    printl(e)
    local lizard = FindTheLizard();
    local Chat = @(m) ClientPrint(lizard, 3, m)
    Chat(format("\nAN ERROR HAS OCCURRED [%s]", e))
    Chat("CALLSTACK")
    local s, l = 2
    while (s = getstackinfos(l++))
        Chat(format("*FUNCTION [%s()] %s line [%d]", s.func, s.src, s.line))
    Chat("LOCALS")
    if (s = getstackinfos(2))
        foreach (n, v in s.locals) {
            local t = type(v)
            t ==    "null" ? Chat(format("[%s] NULL"  , n))    :
            t == "integer" ? Chat(format("[%s] %d"    , n, v)) :
            t ==   "float" ? Chat(format("[%s] %.14g" , n, v)) :
            t ==  "string" ? Chat(format("[%s] \"%s\"", n, v)) :
                             Chat(format("[%s] %s %s" , n, t, v.tostring()))
        }
})