moveSpeed <- 0;
spareTimeStamp <- 0;
hasJumped <- 0;

PrecacheSound("vo/mercenary_jump01.mp3")
PrecacheSound("vo/mercenary_jump02.mp3")
PrecacheSound("vo/mercenary_jump03.mp3")

vo_jump_sounds <- ["vo/mercenary_jump01.mp3", "vo/mercenary_jump02.mp3", "vo/mercenary_jump03.mp3"]

AddTimer(-1, 0, function()
{
    //todo use m_bJumping
    local entIndex = self.entindex();
    if (self.GetFlags() & FL_ONGROUND)
        hasJumped = false;
    else if (!hasJumped && (GetPropInt(self, "m_nButtons") & IN_JUMP))
    {
        hasJumped = true;
        EmitSoundEx({
            sound_name = vo_jump_sounds[RandomInt(0, vo_jump_sounds.len() - 1)],
            entity = self,
            volume = 0.6,
            sound_level = 90,
        });
    }

    local newSpeed = self.GetAbsVelocity().Length2D();
    if (!(self.GetFlags() & FL_ONGROUND))
    {
        spareTimeStamp = Time();
        if (newSpeed > 310)
        {
            local delta = (newSpeed - 310) / 520;
            if (moveSpeed < 70)
                moveSpeed += 0.2 + delta;
        }
    }
    else if (newSpeed < 250)
    {
        moveSpeed = clampFloor(0, moveSpeed - 2);
    }
    else if (Time() - spareTimeStamp > 0.2)
    {
        moveSpeed = clampFloor(0, moveSpeed - 1.2);
    }
    if (moveSpeed > 50 && self.GetAbsVelocity().Length2D() > 480)
        self.AddCondEx(TF_COND_SPEED_BOOST, 0.3, self);
    if (RandomInt(1, 10) == 1)
        self.AddCustomAttribute("move speed bonus",
            1.04 / MERC_MOVESPEED_MULTIPLIER[self.GetPlayerClass()] + moveSpeed / 70.0,
            -1);
});