::handsModel <- null;
::viewModel <- null;
::worldModel <- null;

function RefreshModels()
{
    local weaponEnt = self.GetActiveWeapon();
    local weaponTT = GetWeaponTypeFromEntity(weaponEnt);
    if (!weaponTT)
        return;

    local entsToKill = [];
    for(local viewmodel = null; viewmodel = Entities.FindByClassname(viewmodel, "tf_wearable*");)
        if (viewmodel.GetOwner() == self)
            entsToKill.push(viewmodel);
    foreach (ent in entsToKill)
        ent.Kill();

    local viewModel = GetPropEntity(self, "m_hViewModel");
    viewModel.DisableDraw();

    TrySpawnViewModel().SetModelSimple("models/weapons/c_models/c_merc_arms.mdl");

    if ("animmodel" in weaponTT)
    {
        weaponEnt.SetModelSimple(weaponTT.animmodel);
        weaponEnt.SetCustomViewModelModelIndex(GetModelIndex(weaponTT.animmodel));
        SetPropInt(weaponEnt, "m_iViewModelIndex", GetModelIndex(weaponTT.animmodel));

        self.Weapon_Switch(weaponEnt);
        viewModel.DisableDraw();
    }
    if ("weaponmodel" in weaponTT)
    {
        TrySpawnViewModel().SetModelSimple(weaponTT.weaponmodel);
        TrySpawnWorldModel().SetModelSimple(weaponTT.weaponmodel);
        weaponEnt.DisableDraw();
    }
    else
    {
        SetPropInt(TrySpawnViewModel(), "m_nModelIndex", GetPropInt(weaponEnt, "m_iWorldModelIndex"))
    }
}

function TrySpawnWorldModel()
{
    local newWorldModel = SpawnEntityFromTable("tf_wearable", { });
    SetPropBool(newWorldModel, "m_bForcePurgeFixedupStrings", true);
    SetPropBool(newWorldModel, "m_bValidatedAttachedEntity", true);
    SetPropBool(newWorldModel, "m_AttributeManager.m_Item.m_bInitialized", true);
    EntFireByHandle(newWorldModel, "SetParent", "!activator", 0, self, self);
	SetPropEntity(newWorldModel, "m_hOwnerEntity", self);
    newWorldModel.SetOwner(self);
    worldModel = newWorldModel;
	return newWorldModel;
}

function TrySpawnViewModel()
{
    local newViewModel = SpawnEntityFromTable("tf_wearable_vm", { })
    SetPropBool(newViewModel, "m_bForcePurgeFixedupStrings", true);
    self.EquipWearableViewModel(newViewModel);
    viewModel = newViewModel;

    /*AddTimer(1, function()
    {
        local weapon = self.GetActiveWeapon();
        if (!weapon)
            return;
        for (local i = 0; i < 5; i++)
        {
            if (!self.IsFakeClient())
                printl(weapon+" "+weapon.GetBodygroup(i))
            self.SetBodygroup(i, weapon.GetBodygroup(i));
        }
    }, viewModel);*/

	return newViewModel;
}